VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmGSSTATMain 
   AutoRedraw      =   -1  'True
   BackColor       =   &H8000000C&
   Caption         =   "GSSTAT"
   ClientHeight    =   7860
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10680
   BeginProperty Font 
      Name            =   "Calisto MT"
      Size            =   15.75
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   7860
   ScaleWidth      =   10680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdClearWin 
      Caption         =   "Clear Status  Window"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2040
      TabIndex        =   33
      ToolTipText     =   "Erases info. window only. Does not alter any data."
      Top             =   6960
      Width           =   1935
   End
   Begin VB.Frame FrameSMD 
      BackColor       =   &H8000000C&
      Caption         =   "Smallest measured &Dia."
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1215
      Left            =   8520
      TabIndex        =   27
      Top             =   2280
      Width           =   2055
      Begin VB.TextBox TextSMD 
         BeginProperty DataFormat 
            Type            =   1
            Format          =   "0.000"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   1
         EndProperty
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   345
         Left            =   360
         TabIndex        =   29
         Top             =   720
         Width           =   615
      End
      Begin VB.Label Label5 
         BackColor       =   &H8000000C&
         Caption         =   " m"
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   12
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   1200
         TabIndex        =   32
         Top             =   840
         Width           =   375
      End
      Begin VB.Label Label4 
         BackColor       =   &H8000000C&
         Caption         =   "m"
         BeginProperty Font 
            Name            =   "Symbol"
            Size            =   12
            Charset         =   2
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   1080
         TabIndex        =   31
         Top             =   840
         Width           =   135
      End
      Begin VB.Label Label2 
         BackColor       =   &H8000000C&
         Caption         =   "Needed if extrapolation has been selected."
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   120
         TabIndex        =   28
         Top             =   240
         Width           =   1815
      End
   End
   Begin VB.Frame Frame_Extrap 
      BackColor       =   &H8000000C&
      Caption         =   "Extrapolation Method  (if any)"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1335
      Left            =   3240
      TabIndex        =   22
      Top             =   2280
      Width           =   5055
      Begin VB.OptionButton optELin 
         BackColor       =   &H8000000C&
         Caption         =   "&Linear"
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   240
         TabIndex        =   24
         ToolTipText     =   " Linear extrapolation may tend to over-estimate the clay present"
         Top             =   840
         Width           =   2175
      End
      Begin VB.OptionButton optEAvg 
         BackColor       =   &H8000000C&
         Caption         =   "&Averaged (recommended)"
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   2640
         TabIndex        =   26
         Top             =   840
         Width           =   2055
      End
      Begin VB.OptionButton optEExp 
         BackColor       =   &H8000000C&
         Caption         =   "E&xponential"
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   2640
         TabIndex        =   25
         Top             =   360
         Width           =   2055
      End
      Begin VB.OptionButton optENone 
         BackColor       =   &H8000000C&
         Caption         =   "None (&default)"
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   240
         TabIndex        =   23
         ToolTipText     =   "No fine extrapolation will be performed."
         Top             =   360
         Value           =   -1  'True
         Width           =   2175
      End
   End
   Begin VB.Frame Frame3OutFmt 
      BackColor       =   &H8000000C&
      Caption         =   "Output File Format"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   8520
      TabIndex        =   17
      Top             =   4440
      Width           =   2055
      Begin VB.OptionButton Option4 
         BackColor       =   &H8000000C&
         Caption         =   "C&um. Freq.%"
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   480
         Left            =   1080
         TabIndex        =   21
         Top             =   240
         Value           =   -1  'True
         Width           =   855
      End
      Begin VB.OptionButton Option3 
         BackColor       =   &H8000000C&
         Caption         =   "Fre&q.%"
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   120
         TabIndex        =   20
         Top             =   240
         Width           =   855
      End
   End
   Begin VB.Frame Frame2InFmt 
      BackColor       =   &H8000000C&
      Caption         =   "Input File Format"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   8520
      TabIndex        =   16
      Top             =   3480
      Width           =   2055
      Begin VB.OptionButton Option2 
         BackColor       =   &H8000000C&
         Caption         =   "&Cum. Freq.%"
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   480
         Left            =   1080
         TabIndex        =   19
         Top             =   240
         Value           =   -1  'True
         Width           =   855
      End
      Begin VB.OptionButton Option1 
         BackColor       =   &H8000000C&
         Caption         =   "&Freq.%"
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   480
         Left            =   120
         TabIndex        =   18
         Top             =   240
         Width           =   855
      End
   End
   Begin VB.ListBox lstViewScreen 
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1080
      ItemData        =   "frmGSSTATMain.frx":0000
      Left            =   240
      List            =   "frmGSSTATMain.frx":0002
      TabIndex        =   14
      TabStop         =   0   'False
      ToolTipText     =   "Display window only! Don't type in here."
      Top             =   5400
      Width           =   10335
   End
   Begin VB.CommandButton cmdAbout 
      Caption         =   "Informatio&n"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   480
      TabIndex        =   13
      ToolTipText     =   "More info about this program"
      Top             =   6960
      Width           =   1095
   End
   Begin VB.CommandButton cmdRun 
      Caption         =   "&RUN"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   4680
      MaskColor       =   &H00808080&
      Style           =   1  'Graphical
      TabIndex        =   12
      ToolTipText     =   "Starts the data conversion"
      Top             =   6840
      Width           =   1335
   End
   Begin VB.CommandButton cmdRestart 
      Caption         =   "Re&set-Restart"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   6720
      Style           =   1  'Graphical
      TabIndex        =   11
      ToolTipText     =   "Set up for an all new data classification run."
      Top             =   6960
      Width           =   1815
   End
   Begin VB.TextBox TxtOutfilePath 
      BackColor       =   &H8000000C&
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   2280
      TabIndex        =   8
      Text            =   "Output Filename/path not set"
      ToolTipText     =   "Display window only! Don't type in here."
      Top             =   4560
      Width           =   6015
   End
   Begin VB.TextBox TxtInfilePath 
      BackColor       =   &H8000000C&
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   2280
      TabIndex        =   7
      Text            =   "Input Filename/path not set"
      ToolTipText     =   "Display window only! Don't type in here."
      Top             =   3960
      Width           =   6015
   End
   Begin VB.CommandButton cmdSetOutput 
      BackColor       =   &H0080FFFF&
      Caption         =   "Set &Output File"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   240
      Style           =   1  'Graphical
      TabIndex        =   6
      ToolTipText     =   "User can set or modify output file name & path"
      Top             =   4440
      Width           =   1815
   End
   Begin VB.CommandButton cmdSetInput 
      BackColor       =   &H0080FFFF&
      Caption         =   "Select &Input File"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   240
      Style           =   1  'Graphical
      TabIndex        =   5
      ToolTipText     =   "User can browse or enter input file name & path"
      Top             =   3840
      Width           =   1815
   End
   Begin MSComDlg.CommonDialog dlgFiles 
      Left            =   7440
      Top             =   4200
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DefaultExt      =   "txt"
      DialogTitle     =   "Open File for Input"
      Filter          =   "Textfiles (*.txt)|*.txt|Comma delimited (*.csv)|*.csv|Other (*.*)|*.*"
      FilterIndex     =   1
      InitDir         =   "C:\*.*"
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "&Close"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   9000
      TabIndex        =   1
      ToolTipText     =   "Ends the program and returns to system."
      Top             =   6960
      Width           =   1215
   End
   Begin VB.Frame Frame1Stat 
      BackColor       =   &H0080FFFF&
      Caption         =   "Select Statistics Method"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1335
      Left            =   240
      TabIndex        =   2
      Top             =   2280
      Width           =   2655
      Begin VB.OptionButton optIG 
         BackColor       =   &H0080FFFF&
         Caption         =   "Inclusive &Graphics"
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   240
         TabIndex        =   4
         ToolTipText     =   "Sets I.G. method. Click Information button for description."
         Top             =   720
         Width           =   2175
      End
      Begin VB.OptionButton optMM 
         BackColor       =   &H0080FFFF&
         Caption         =   "&Method of Moments"
         BeginProperty Font 
            Name            =   "Calisto MT"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   240
         TabIndex        =   3
         ToolTipText     =   "Sets M.M. method. Click Information button for description."
         Top             =   360
         Width           =   2175
      End
   End
   Begin VB.Label Label3 
      BackColor       =   &H8000000C&
      Caption         =   "Information and Status Window"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   3960
      TabIndex        =   30
      Top             =   5160
      Width           =   2895
   End
   Begin VB.Label lblNoMouse 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000003&
      Caption         =   "On systems with no mouse you may hold down ""Alt"" and press the underlined letter to select options. Alt-F4 closes Window"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   480
      TabIndex        =   15
      Top             =   7560
      Width           =   9735
   End
   Begin VB.Label LblOutputFile 
      BackColor       =   &H8000000C&
      Caption         =   "Output Path"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   4440
      TabIndex        =   10
      Top             =   4320
      Width           =   1455
   End
   Begin VB.Label LblInputFile 
      BackColor       =   &H8000000C&
      Caption         =   "Input Path"
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   4440
      TabIndex        =   9
      Top             =   3720
      Width           =   1335
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackColor       =   &H00004080&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "GSSTAT          Grain Size Statistics Program     "
      BeginProperty Font 
         Name            =   "Calisto MT"
         Size            =   20.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H8000000E&
      Height          =   615
      Left            =   120
      TabIndex        =   0
      ToolTipText     =   "Version 2.04  Click ""Information"" for usage"
      Top             =   1320
      Width           =   10455
   End
   Begin VB.Image Image1 
      BorderStyle     =   1  'Fixed Single
      Height          =   1140
      Left            =   120
      Picture         =   "frmGSSTATMain.frx":0004
      ToolTipText     =   "Cape Cod, Massachusetts"
      Top             =   120
      Width           =   10485
   End
End
Attribute VB_Name = "frmGSSTATMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Program GSSTAT
'Title:
'A Visual Basic Program to generate statistics for grain-size distributions
'and to extrapolate distributions to the colloidal/clay boundry
'Authors:
'L.J.Poppe, A.H.Eliason
'Version:  2.04    August 28, 2003
'Development Language:  VB 6.0 Professional
'Minimum known working Environment:   Pentium II, 166Kbps,  MS Windows 98, 64 MB RAM
'

' Values for intFlgs ( )
' (0) True = Valid Input filename
' (1) True = Valid Output filename
' (2) = 0 Stat Method not set , 1 M.Moments, 2 I.Graphics
' (3) True = A data conversion run has been completed
' (4) True = CFP not 100% +- 0.2
' (5) True = Bad Input file format
' (6) Extrap, 0 not set, 1 None, 2 Lin, 3 Exp, 4 Mean (Avg.)
' (7) 0 OK, 1= Need Smallest Micron Diameter, 2= SMD Out of range
' (8) False In Format not set, 1 input is FP format, 2 input is CFP format
' (9) False Out Format not set, 1 output is FP format, 2 output is CFP format
'(10) True = A non-numeric character was found in one or more numeric input fields
'(11) True = An error occured somwhere in the data run but a complete file was written


Dim Lable$(10)
Dim intFlgs(15) As Integer
Dim strInFile As String * 255
Dim strOutFile As String * 255
Dim strMethod As String * 6
Dim SMD As Single
Dim flgDebug As Integer
Dim Xfit(3) As Integer
Dim Yfit(3) As Double
Dim strNumIn As String                   ' String that is tested for valid numeric input

Private Sub cmdRun_Click()
Dim strClass As String          ' Classification type
Dim i As Integer
Dim j As Integer
Dim k As Integer
Dim IP As Integer

Dim intReply As Integer         ' Integer replies from subs & function calls
Dim intNP As Integer            ' Num points
Dim intXval As Integer

Dim Itext(50) As String         ' Temporary string
Dim ndxNZ As Integer            ' Index pointer
Dim OutLable(35) As String
Dim strSn As String             ' Sample Number Text
Dim strLon As String            ' Longetude text
Dim strLat As String            ' Latitude text

Dim strRecord As String         '  ???
Dim PHIP(32) As Integer         ' Phi Classes as integers -5 to 13
Dim CFPNDX(32) As Integer       ' index array 1-20
Dim CFP(32) As Double           ' Cumulative Frequency Percents
Dim CFPcor(32) As Double
Dim F(32) As Double             ' temp
Dim FP(32) As Double            ' Natural Frequency Percents
Dim RFPcor(32) As Double        ' Corrected CFP
Dim FPcor(32) As Double         ' Corrected FP
Dim Fpp(32) As Double           ' Used for S/W statistics

On Error GoTo AHError
'intReply = MsgBox("This is not an approved version" + Chr$(10) + "of the program. It is for development testing only." + Chr$(10) + "For evaluation To LJP et al. 7/20/03")
' init/change the file i/o formats
If Option1.Value Then intFlgs(8) = 1      ' init for FP input format
If Option2.Value Then intFlgs(8) = 2      ' init for CFP input format
If Option3.Value Then intFlgs(9) = 1      ' init for FP output format
If Option4.Value Then intFlgs(9) = 2      ' init for CFP output format

intFlgs(9) = 2      ' init for CFP output format

If intFlgs(3) = 1 Then intReply = MsgBox("You have already converted this file." + Chr$(10) + "Do you really want to run again?", vbOKCancel)
If intReply = 2 Then Exit Sub                       ' get out    2=cancel
lstViewScreen.Clear
lstViewScreen.BackColor = &HFFFFFF          '  White

Call RunStat(iRun)
If Not iRun Then
    MsgBox "Setup Parameter missing - can not run"
    Exit Sub
End If

If intFlgs(6) > 1 Then              'Set up for Extrapolation

    If SMD < 0.1 Then               ' Exit if too small
        MsgBox ("Smallest Measured Diameter is too small. The program is expecting" + Chr$(10) + _
        "a size of 0.1 m, or greater.")
        If intFlgs(6) > 1 Then FrameSMD.BackColor = &H80FFFF
        Exit Sub
    End If
    If SMD > 2 Then intReply = MsgBox("You have selected extraploation from above 2 m." + Chr$(10) + _
    "A significant portion of the grain size distribution will be extrapolated." + Chr$(10) + _
    "This may cause your statistics to be invalid." + Chr$(10) + Chr$(10) + _
    "Click OK to continue or CANCEL to stop and re-enter the SMD.", vbOKCancel)
    If intReply = 2 Then            ' 2=cancel    Exit if user clicks cancel
        intFlgs(7) = 2
        Call CngFlgs
        Call RunStat(iRun)
        If intFlgs(6) > 1 Then FrameSMD.BackColor = &H80FFFF
        Exit Sub
    End If                          ' User says that's OK
    
    PhiNudge = 0.045  ' this factor is added to conversions from micron dia to Phi
               ' in order to adjust for the offset between whole micron
               ' diamaters and phi boundries eg: 1 micron actually= 9.965..Phi
               ' so we add .045 to Phi in order to cross the 10 Phi boundry.

    PhiMin = U2Phi(SMD)           ' actulal phi size
    PhiMin = PhiMin + PhiNudge    ' correct to USGS boundry
    intPhi = Int(PhiMin)          ' Integer portion of smallest measured
    IntPhiFrac = intPhi + 1       ' Fraction containing the smallest meas.
    ndxPhiCor = IntPhiFrac + 6    ' index to Fraction Array
    PhiCorFac = PhiMin - intPhi   ' divisor for correction
    PctPhiCor = 100 - Int(PhiCorFac * 10000) / 100    ' just for information
    If flgDebug Then
        If flgDebug Then lstViewScreen.AddItem "*DIAG*  The value you entered corresponds to " + Left$(Str$(PhiMin), 6) + "Phi"
        If flgDebug Then lstViewScreen.AddItem "   The " + Str$(IntPhiFrac) + " Phi Fraction will be increased in order to account"
        If flgDebug Then lstViewScreen.AddItem "   for the " + Str$(PctPhiCor) + " percent perceived to be undetected in this fraction."
        If flgDebug Then lstViewScreen.AddItem "   The value will be divided by " + Left$(Str$(PhiCorFac), 7) + "    *END DIAG*"
    End If
End If
'Read Output Headers from file
If flgDedug Then lstViewScreen.AddItem "Reading Output Header"
    Open App.Path & "\GSSTAT OUT HEADER.txt" For Input As #1
    A$ = ""
    For i = 1 To 33
        Input #1, OutLable(i)
        A$ = A$ + OutLable(i) + " "
        If i = 10 Or i = 20 Or i = 30 Or i = 35 Then
            'If flgDebug Then
            If flgDedug Then lstViewScreen.AddItem A$
            A$ = ""
        End If
        If EOF(1) Then Exit For
    Next i
    
    Close #1

    lstViewScreen.AddItem "Opening: " + strInFile + " for input."
    Open strInFile For Input As #1              ' re-open
    Line Input #1, A$                           ' pull the header
    Open strOutFile For Output As #2            ' open the output file
    For i = 1 To 33
        Print #2, OutLable(i); ",";
    Next i
    Print #2, "ERRORS"
        
        

    strExType = "None"                      'default- no extrap
    If intFlgs(6) = 2 Then strExType = "Lin."
    If intFlgs(6) = 3 Then strExType = "Exp."
    If intFlgs(6) = 4 Then strExType = "Avg."

'Do While Not EOF(1)                         ' begin main loop
'*********************************************************

NextSamp:

    'Parse the input record for data fields
    'Parse comma delimited input A$
    
    Erase Itext                             'zero array
    Line Input #1, A$                       'get record
    lstViewScreen.AddItem A$
    L = Len(A$)                             'length of line
    P1 = 1                                  'init pointers
    P2 = 1
    For i = 1 To 50                         'just use a number larger than needed
      P2 = InStr(P1, A$, ",")               'Find next comma position at or after P1
      If P2 = 0 Then P2 = L + 1             'P2 needs to be larger than P1
      Itext(i) = Mid$(A$, P1, P2 - P1)      'rem - it's Var,Start,Length
      If P2 = L + 1 Then Exit For           'No more commas
      P1 = P2 + 1                           'Increment past last comma
    Next i                                  'Go for next string
    
    intNumFields = i
    If intNumFields <> 20 Then lstViewScreen.AddItem "Found " + Str$(i) + " input fields"
    If flgDebug Then
        For i = 1 To 20
          lstViewScreen.AddItem Str$(i) + "~" + Itext(i)
        Next i
        lstViewScreen.AddItem ""
    End If
    intFlgs(5) = False
    If intNumFields < 20 Then
        lstViewScreen.ListIndex = lstViewScreen.ListCount - 1
        intReply = MsgBox("A required field was missing while examining this input record." + Chr$(10) + _
        "This will corrupt the data for this sample." + Chr$(10) + _
        "Click OK to mark the record bad and continue, or Cancel to " + Chr$(10) + _
        "return to the setup screen and quit, repair the file, and then restart.", vbOKCancel)
        If intReply = 2 Then                      ' get out    2=cancel
            Close
            Exit Sub
        Else
            intFlgs(5) = True                           ' Flag bad format missing field
            intFlgs(11) = True                          ' Error noted but continue
            Call CngFlgs
        End If                                          ' User says that's OK
End If
    
    
    
    
For j = 0 To 32
     PHIP(j) = j - 6: FP(j) = 0: CFP(j) = 0: FPcor(j) = 0: RFPcor(j) = 0 'init the arrays
    F(j) = 0: Fpp(j) = 0: CFPcor(j) = 0
Next j
intFlgs(4) = False                           ' Flag CFP = 100 until tested
' Now convert Cumulative Fq% or Fq% text to numeric forms.
' test here to confirm FP or CFP was input format as set by user

Cumul = 0: FqPct = 0: j = 1: PSz = -5
intFlgs(10) = False                                 ' Reset invalid character flag
For i = 20 To 4 Step -1                             ' step from largest to smallest size in the input
    strNumIn = Itext(i)                             ' set string for test for invalid numeric characters
    Call TestValNum
    If intFlgs(8) = 2 Then                          ' text array, that is, -5 to 11 PHI in that order
        FqPct = Val(Itext(i)) - Cumul               ' convert to FP
    Else                                            ' its already in fp
        FqPct = Val(Itext(i))                       ' so just take the value
    End If
         
     FqPct = Int(FqPct * 100 + 0.499999999) / 100   ' round to two places
     Cumul = Cumul + FqPct                          ' Convert back to cumulative
     CFP(j) = Cumul                                 ' Numeric CFP AHE 03/03
     PHIP(j) = PSz                                  ' Phi Size
     PSz = PSz + 1
     FP(j) = FqPct                                  ' Actual phi percentage
     If flgDedug Then lstViewScreen.AddItem Str$(FP(j)) + " " + Str$(PHIP(j)) + " " + Str$(CFP(j))
     j = j + 1                                      ' j steps from 1 to 17
     
Next i
For j = 18 To 20
    CFP(j) = CFP(17)
    FP(j) = 0#
    PHIP(j) = j - 6
    If flgDedug Then lstViewScreen.AddItem Str$(FP(j)) + " " + Str$(PHIP(j)) + " " + Str$(CFP(j))
Next j
    
'*** PHIP(j) now contains -5 at 1, -4 at 2,... 11phi at 17 ***
'    FP(j) and CFP(j) the Freq% and CumulFreq% to two decimal places

'   If Cumul<>100 then something went wrong

If Cumul > 110 Or Cumul < 90 Then                   ' Gross error - probably Format
    lstViewScreen.ListIndex = lstViewScreen.ListCount - 1
    intReply = MsgBox("A large error occurred while examining the input record." + Chr$(10) + _
    "This may be due to incorrect input file format, F% vs CF%." + Chr$(10) + _
    "Click OK to mark the record bad and continue, or Cancel to " + Chr$(10) + _
    "return to the setup screen and change the file format button, then restart.", vbOKCancel)
    If intReply = 2 Then                      ' get out    2=cancel
        'lstViewScreen.Clear
        Print #2, " User ABORTED this data run."
        Close
        Exit Sub
    Else
        intFlgs(4) = True                           ' Flag CFP <> 100
        intFlgs(11) = True
        Call CngFlgs
        
    End If                                          ' User says that's OK
End If
If Cumul > 100.2 Or Cumul < 99.8 Then               ' Flag if CFP not 100 +/- 0.2
    intFlgs(4) = True
    Call CngFlgs
    lstViewScreen.AddItem Str$(Cmul) + " CFP is not 100 +/- 0.2"
End If
If intFlgs(10) Then                   ' Non Numeric character
    lstViewScreen.ListIndex = lstViewScreen.ListCount - 1
    intReply = MsgBox("A non-numeric character was found in one or more of these input fields." + Chr$(10) + _
    "This may be due to an alpha O instead of a numeric zero " + Chr$(10) + _
    "Click OK to mark the record bad and continue, or Cancel to " + Chr$(10) + _
    "close the output file and return to the setup screen.", vbOKCancel)
    If intReply = 2 Then                      ' get out    2=cancel
        intFlgs(10) = False                   ' Reset error
        Print #2, " User ABORTED this data run."
        Close
        Exit Sub
    Else
        'intFlgs(10) = True                         ' remains true
        intFlgs(11) = True                          ' Error was noted
    End If                                          ' User says that's OK
End If
' Let's move on to calculations, Kimosabi

 N = 20                             ' -5 to 14 phi FRACTION inclusive
 DPHI = 1                           ' Delta Phi
' Fpp() was F() in the original program
' Need to load arrays in case of no extrapolation
For i = 1 To 20
    Fpp(i) = FP(i)
    FPcor(i) = FP(i)
    CFPcor(i) = CFP(i)
Next i
 
Extrapolate:
If intFlgs(6) < 2 Then GoTo Output  ' No extrapolation requested'

If flgDedug Then lstViewScreen.AddItem "Doing the initial Extrapolation"

For i = N To 1 Step -1              ' find the smallest non-zero fraction
     If FP(i) > 0 Then
          ndxNZ = i                 ' ndxNZ= index to smallest FRACTION with data
          Exit For
     End If
Next i
' Make the percentage correction to the fraction containg the smallest
' measurable data
imin = ndxPhiCor
If FP(imin) > 0 Then
     FPcor(imin) = FP(imin) / PhiCorFac
     If flgDedug Then lstViewScreen.AddItem "The smallest measured fraction is " + Str$(IntPhiFrac) + " Phi, with a value of " + Str$(FP(imin))
     If flgDedug Then lstViewScreen.AddItem Str$(FP(imin)) + " has been changed to " + Str$(FPcor(imin))
     If flgDedug Then lstViewScreen.AddItem ""
Else
     If flgDedug Then lstViewScreen.AddItem Str$(IntPhiFrac) + " Phi fraction was zero so it needed no change."
     If flgDedug Then lstViewScreen.AddItem ""
End If

' Now do Extrapolation from the smallest non zero fraction to 14 FRACTION
' which is zero. Reminder: the 13 FRACTION contains the 12.001 to 13 data

If flgDebug Then
    lstViewScreen.AddItem "The smallest non-zero fraction is " + Str$(PHIP(ndxNZ)) + " Phi with a value of " + Str$(FPcor(ndxNZ)) + "%"
    If intFlgs(6) = 2 Then lstViewScreen.AddItem "Linear "
    If intFlgs(6) = 3 Then lstViewScreen.AddItem "Exponential "
    If intFlgs(6) = 4 Then lstViewScreen.AddItem "Mean of L./E.(Averaged)"
    If intFlgs(6) <> 4 And intFlgs(6) <> 3 And intFlgs(6) <> 2 Then lstViewScreen.AddItem "error at ExType. Program halted.": Stop
    lstViewScreen.AddItem "Extrapolation will now be performed to 13 Phi.(14 Phi Fraction=0)"
    lstViewScreen.AddItem ""
End If
' Set up for calls to FFIT (Linear and Exponential)
Index = ndxNZ
Xfit(1) = Index
Yfit(1) = FPcor(Index)

Xfit(2) = Index               ' zero slope
Yfit(2) = FPcor(Index)        ' here we set the slope to zero and extrapolate
                              ' to y= .0000001  i.e. 14 Phi = .0000001
Xfit(3) = 20
Yfit(3) = 0.0000001

Call Ffit(3, Xfit(), Yfit(), 1, Alin, Blin)     ' generate linear coeficients
Call Ffit(3, Xfit(), Yfit(), 3, Aexp, Bexp)     ' generate exponential coeficients
                                                ' note: 4th argument would be 2 for log

Index = ndxNZ
'Npoints = 20 - ndxNZ
'CLinFac = FPcor(Index) / Npoints
For i = Index + 1 To 19
     If intFlgs(6) = 2 Then FPcor(i) = Alin + Blin * i          ' linear
     If intFlgs(6) = 3 Then FPcor(i) = Aexp * Exp(Bexp * i)     ' exponential
     If intFlgs(6) = 4 Then FPcor(i) = ((Alin + Blin * i) + (Aexp * Exp(Bexp * i))) / 2 ' mean
Next i

' Re-normalize FP & CFP to 100 percent
' even if no extrapolation is performed
TotalPct = 0
For i = 1 To 20                                 ' Index 20 = 14 Phi
     TotalPct = TotalPct + FPcor(i)             ' total the FP's
Next i                                          ' TotalPct is OVER 100 now
RevTotalPct = 0                                 ' Reset Revised Total
For i = 1 To 20
     'CFPNDX(i) = i
     RFPcor(i) = 100 * FPcor(i) / TotalPct
     FPcor(i) = RFPcor(i)                       ' need work to eliminate redundant arrays
     FP(i) = RFPcor(i)
     RevTotalPct = RFPcor(i) + RevTotalPct
     CFP(i) = RevTotalPct                       '???  03/03 AHE
     CFPcor(i) = RevTotalPct
Next i
TotalPercent = RevTotalPercent
' End of extrapolation

Output:
If flgDebug Then
    lstViewScreen.AddItem ""
    lstViewScreen.AddItem "                      USGS   Sediment Size Analysis"
    lstViewScreen.AddItem "               Clay Fraction Estimation   Version " + Version$
    lstViewScreen.AddItem ""
    lstViewScreen.AddItem "Sample #     Latitude   Longitude"
    lstViewScreen.AddItem ""
    lstViewScreen.AddItem Itext(1) + Itext(2) + Itext(3)
    lstViewScreen.AddItem ""
    If intFlgs(6) < 2 Then lstViewScreen.AddItem "Non Extrapolated"
    If intFlgs(6) = 2 Then lstViewScreen.AddItem "Revised Linearly"
    If intFlgs(6) = 3 Then lstViewScreen.AddItem "Revised Exponentially"
    If intFlgs(6) = 4 Then lstViewScreen.AddItem "Revised by Mean of Linear and Exponential"
    
    
    lstViewScreen.AddItem "  Phi Size    Freq. %     Freq. %"
    For j = 1 To N
         lstViewScreen.AddItem Str$(PHIP(j)) + "  " + Str$(FP(j)) + "  " + Str$(FPcor(j))
    Next j
    lstViewScreen.AddItem ""
    
End If
    
    
    
    DP = PHIP(2) - PHIP(1)                       '=.5
    Emp1 = PHIP(1) - 0.5 * DP               'Find center of 1st class interval
                                            ' to be used at end for statistics.
    IP = Int((PHIP(N) - PHIP(1)) / DPHI + 1.5)   'Calculate # of Extrapolated points
                                            '(Span/Interp_Interval)+1.5 = # points
'   Check use of IP   Conflicts?
'A. Eliason version of the Lloyd Breslaus Sediment Class Program

If flgDedug Then lstViewScreen.AddItem " Calculating Descriptive Classification Percentages"
If flgDedug Then lstViewScreen.AddItem ""
' Get the new percentages
Gravel = 0
Sand = 0
Silt = 0
Clay = 0

For i = 1 To 5                'Gravel
     Gravel = Gravel + FP(i)
Next i
For i = 6 To 10               'Sand
     Sand = Sand + FP(i)
Next i
For i = 11 To 14              'Silt
     Silt = Silt + FP(i)
Next i
For i = 15 To 20              'Clay
     Clay = Clay + FP(i)
Next i
' give each zero component a tiny weight to prevent division by zero errors
If Sand = 0 Then Sand = 0.00001
If Gravel = 0 Then Gravel = 0.00001
If Silt = 0 Then Silt = 0.00001
If Clay = 0 Then Clay = 0.00001
     Do
          XSand = Sand                              ' Save the original Sand as XSand
          If Gravel >= 50 Then C% = 1: Exit Do
          If Gravel >= 10 Then C% = 2: Exit Do
          
          Sand = Sand + Gravel
          If Sand >= 75 Then C% = 3: Exit Do
          If Silt >= 75 Then C% = 4: Exit Do
          If Clay >= 75 Then C% = 5: Exit Do
      
          ' Sand, Silt, & Clay are all less than 75%
          SanSil = Sand / Silt
          ClySnd = Clay / Sand
          SilCly = Silt / Clay

          If Sand <= 20 Then
               If SanSil > 1 Then C% = 6: Exit Do
               If SilCly < 1 Then C% = 7: Exit Do
               If ClySnd > 1 Then
                    C% = 8: Exit Do
               Else: C% = 9: Exit Do
               End If
          Else                          ' Sand> 20%
       
               If Clay <= 20 Then
                    If SanSil < 1 Then C% = 9: Exit Do
                    If SilCly > 1 Then C% = 10: Exit Do
                    If ClySnd > 1 Then
                         C% = 6: Exit Do
                    Else
                         C% = 11: Exit Do
                    End If
               Else                          ' Clay > 20%

                    If Silt > 20 Then C% = 12: Exit Do
                    If ClySnd > 1 Then
                         C% = 6: Exit Do
                    Else
                         C% = 11: Exit Do
                    End If
               End If
          End If
          If flgDebug Then lstViewScreen.AddItem "ERROR IN BRESLAU ROUTINE": Beep: End
     Loop
Select Case C%
     Case 1
          strCaseName = "GRAVEL"
     Case 2
          strCaseName = "GRAVELLY SEDIMENT"
     Case 3
          strCaseName = "SAND"
     Case 4
          strCaseName = "SILT"
     Case 5
          strCaseName = "CLAY"
     Case 6
          strCaseName = "SANDY CLAY"
     Case 7
          strCaseName = "SILTY CLAY"
     Case 8
          strCaseName = "CLAYEY SILT"
     Case 9
          strCaseName = "SANDY SILT"
     Case 10
          strCaseName = "SILTY SAND"
     Case 11
          strCaseName = "CLAYEY SAND"
     Case 12
          strCaseName = "SAND SILT CLAY"
     Case Else
          strCaseName = "Error in classification routine"
End Select

If flgDedug Then lstViewScreen.AddItem "Gravel %     " + Str$(Gravel)
If flgDedug Then lstViewScreen.AddItem "Sand   %     " + Str$(XSand)
If flgDedug Then lstViewScreen.AddItem "Silt   %     " + Str$(Silt)
If flgDedug Then lstViewScreen.AddItem "Clay   %     " + Str$(Clay)
     Total = Gravel + XSand + Silt + Clay
     If flgDedug Then lstViewScreen.AddItem "             Total = " + Str$(Total)
     'If flgDedug Then lstViewScreen.AddItem ""
If flgDedug Then lstViewScreen.AddItem "Sediment Classification:  " + strCaseName        'Breslau
Verbal$ = strCaseName
If flgDedug Then lstViewScreen.AddItem ""
     'If Lprnt Then
     'LPRINT "           Original      Revised"
     'LPRINT USING "     Gravel % ##.##        ##.##"; VAL(Itext(18)); Gravel
     'LPRINT USING "     Sand   % ##.##        ##.##"; VAL(Itext(17)); XSand
     'LPRINT USING "     Silt   % ##.##        ##.##"; VAL(Itext(19)); Silt
     'LPRINT USING "     Clay   % ##.##        ##.##"; VAL(Itext(20)); Clay

     'LPRINT USING "                  Total = ###.##"; Total
     'LPRINT
     'LPRINT "     Revised Classification:  "; strCaseName
     'LPRINT

    'End If


'Scale the data for plotting
Ymax = 0: CT = 0

For i = 1 To IP
    Fpp(i) = FP(i)                      ' load Fpp for S/W stats later
    If Fpp(i) > Ymax Then Ymax = Fpp(i)
    CT = CT + Fpp(i)
    If flgDedug Then lstViewScreen.AddItem Str$(i - 6.99) + " " + Str$(i - 6) + " " + Str$(Fpp(i)) + " " + Str$(CT) + " " + Str$(CFP(i))
Next i


' The INCLUSIVE GRAPHICS estimations
' This is the routine to get values for Phi5, Phi16, Phi25,
' Phi50 Phi75, Phi84, and Phi95 for use in the equations (Folk 74)
' for (IG Standard Deviation, IG Skewness, and Graphic Kurtosis
' The Variables Phixx are the interpolated values of Phi for the cumulative
' percentages xx, within a given sample.
' At this point in the program the index value 1 points to -5 Phi which must
' contain a zero indicating that no materials larger than -4 Phi are included.
' Values of FP and CFP (Frequency Percent and Cumulative Frequnccy Percent.
' are zero.
' Index 20 points to 14 Phi which also contains a zero FP and a CFP value
' of 100 indicating that no size equal or smaller than 14 Phi is measured or
' has been estimated.

' Test Kruger SplineX3 ***************************************************
     If flgDebug Then lstViewScreen.AddItem "AHE Running Kruger SplineX3 ..."
     If flgDedug Then lstViewScreen.AddItem "   CFP X         CFPNDX Y"
     PtrLo = 0: PtrHi = 0
     For i = 1 To 20
        CFPNDX(i) = i
        If CFP(i) <= 0 Then PtrLo = i: CFP(i) = 0
        If flgDedug Then lstViewScreen.AddItem Str$(CFP(i)) + "      " + Str$(CFPNDX(i))
        If CFP(i) > CFP(PtrHi) Then PtrHi = i           ' cut 1 7/22/03
     Next i
     If flgDebug Then
        lstViewScreen.AddItem "PtrLo= " + Str$(PtrLo) + " PtrHi= " + Str$(PtrHi)
        lstViewScreen.AddItem "CFP(PtrLo)= " + Str$(CFP(PtrLo)) + " CFP(PtrHi) = " + Str$(CFP(PtrHi))
     End If
     If CFP(PtrLo) = 0 Then PtrLo = PtrLo + 1           'Throw out zero value
     N = (PtrHi - PtrLo) + 1
     
     For i = 1 To N + 1                                 ' shift the values down so that the
        CFP(i - 1) = CFP((i - 1) + PtrLo - 1)           ' array has only one zero and hundred
        CFPNDX(i - 1) = CFPNDX((i - 1) + PtrLo - 1)     ' Base 0
     Next i
     intNP = N              '- 1                        ' Because base 0
'PressAnyKey

    If flgDebug Then
        lstViewScreen.AddItem "Data for Interpolation: X, Y, Phi"
        For i = 0 To intNP
           lstViewScreen.AddItem Str$(CFP(i)) + " " + Str$(CFPNDX(i)) + " " + Str$(CFPNDX(i) - 6)
        Next i
        lstViewScreen.AddItem ""
    End If

    'PressAnyKey
     
     j = 0
     If flgDebug Then
         lstViewScreen.AddItem "0 to 100 CFP Test interpolation"
         For i = 0 To 100 Step 5
            X = i
            Yfitt = SplineX3((intNP), (intXval), CFP(), CFPNDX())
            'Interp Y Value  given --N points, X Value, X(array), Y(array)
                    
            Fpp(j) = Yfitt
            j = j + 1
    
            lstViewScreen.AddItem Str$(i) + " " + Str$(Yfitt - 6)
          Next i
     End If
     'PressAnyKey

     ' Now the real stuff using SplineX3
     intXval = 5
     Yfitt = SplineX3(intNP, intXval, CFP(), CFPNDX())
     Phi5 = Yfitt - 6
     If flgDebug Then lstViewScreen.AddItem "Phi5 = " + "  " + Str$(Yfitt - 6)
    
     intXval = 16
     Yfitt = SplineX3(intNP, intXval, CFP(), CFPNDX())
     Phi16 = Yfitt - 6
     If flgDebug Then lstViewScreen.AddItem "Phi16 = " + Str$(Yfitt - 6)
    
     intXval = 25
     Yfitt = SplineX3(intNP, intXval, CFP(), CFPNDX())
     Phi25 = Yfitt - 6
     If flgDebug Then lstViewScreen.AddItem "Phi25 = " + Str$(Yfitt - 6)
    
     intXval = 50
     Yfitt = SplineX3(intNP, intXval, CFP(), CFPNDX())
     Phi50 = Yfitt - 6
     If flgDebug Then lstViewScreen.AddItem "Phi50 = " + Str$(Yfitt - 6)
    
     intXval = 75
     Yfitt = SplineX3(intNP, intXval, CFP(), CFPNDX())
     Phi75 = Yfitt - 6
     If flgDebug Then lstViewScreen.AddItem "Phi75 = " + Str$(Yfitt - 6)
    
     intXval = 84
     Yfitt = SplineX3(intNP, intXval, CFP(), CFPNDX())
     Phi84 = Yfitt - 6
     If flgDebug Then lstViewScreen.AddItem "Phi84 = " + Str$(Yfitt - 6)
    
     intXval = 95
     Yfitt = SplineX3(intNP, intXval, CFP(), CFPNDX())
     Phi95 = Yfitt - 6
     If flgDebug Then lstViewScreen.AddItem "Phi95 = " + Str$(Yfitt - 6)
     If flgDebug Then lstViewScreen.AddItem ""
    
    
     GrMean = (Phi16 + Phi50 + Phi84) / 3
     SDIG = ((Phi84 - Phi16) / 4) + ((Phi95 - Phi5) / 6.6)
     Vsort$ = "EXTREMELY POORLY SORTED"
     If SDIG < 4 And SDIG >= 2 Then Vsort$ = "VERY POORLY SORTED"
     If SDIG < 2 And SDIG >= 1 Then Vsort$ = "POORLY SORTED"
     If SDIG < 1 And SDIG >= 0.71 Then Vsort$ = "MODERATELY SORTED"
     If SDIG < 0.71 And SDIG >= 0.5 Then Vsort$ = "MODERATELY WELL SORTED"
     If SDIG < 0.5 And SDIG >= 0.35 Then Vsort$ = "WELL SORTED"
     If SDIG < 0.35 Then Vsort$ = "VERY WELL SORTED"
     'Vsort$ = UCase$(Vsort$)
     SkewIG = ((Phi16 + Phi84 - 2 * Phi50) / (2 * (Phi84 - Phi16))) + ((Phi5 + Phi95 - 2 * Phi50) / (2 * (Phi95 - Phi5)))
     GKurt = (Phi95 - Phi5) / (2.44 * (Phi75 - Phi25))

     Vskew$ = "IG SKEW OUT OF LIMITS"
     If SkewIG < 1! And SkewIG >= 0.3 Then Vskew$ = "STRONGLY FINE SKEWED"
     If SkewIG < 0.3 And SkewIG >= 0.1 Then Vskew$ = "FINE SKEWED"
     If SkewIG < 0.1 And SkewIG >= -0.1 Then Vskew$ = "NEAR SYMMETRICAL"
     If SkewIG < -0.1 And SkewIG >= -0.3 Then Vskew$ = "COARSE SKEWED"
     If SkewIG < -0.3 And SkewIG >= -1! Then Vskew$ = "STRONGLY COARSE SKEWED"

     Vkurt$ = "EXTREMLY LEPTOKURTIC"
     If GKurt < 3 And GKurt >= 1.5 Then Vkurt$ = "VERY LEPTOKURTIC"
     If GKurt < 1.5 And GKurt >= 1.1 Then Vkurt$ = "LEPTOKURTIC"
     If GKurt < 1.1 And GKurt >= 0.9 Then Vkurt$ = "MESOKURTIC"
     If GKurt < 0.9 And GKurt >= 0.67 Then Vkurt$ = "PLATYKURTIC"
     If GKurt < 0.67 And GKurt >= 0.41 Then Vkurt$ = "VERY PLATYKURTIC"
     If GKurt < 0.41 Then Vkurt$ = "GRAPHIC KURTOSIS UNDER RANGE"
    
     If flgDebug Then lstViewScreen.AddItem "Graphic Median =      " + Str$(Phi50)
     If flgDebug Then lstViewScreen.AddItem "Graphic Mean =        " + Str$(GrMean)
     If flgDebug Then lstViewScreen.AddItem "I.G. Std. Dev. =      " + Str$(SDIG) + " = " + Vsort$
     If flgDebug Then lstViewScreen.AddItem "I.G. Skewness =       " + Str$(SkewIG) + " = " + Vskew$
     If flgDebug Then lstViewScreen.AddItem "Graphic Kurtosis =    " + Str$(GKurt) + " = " + Vkurt$
     If flgDebug Then lstViewScreen.AddItem ""

STATS:
' now do the statistics via Schlee/Webster 1966

' Start with MODE
'IP = N         ' need if not using schlee-webster
Del1 = -0.1
If flgDedug Then lstViewScreen.AddItem "Method of Moments Statistics"

For i = 2 To IP
     Del2 = Fpp(i) - Fpp(i - 1)
     If ((Del2 * Del1) < 0) And (Del2 < 0) And ((Fpp(i - 1) - 5! * DPHI) > 0) Then
          Xi = i - 2
          Xem = Emp1 + Xi * DPHI
          Xf = Fpp(i - 1)
          i = i + 1
          If flgDedug Then lstViewScreen.AddItem "  Mode      " + Str$(Xem) + " " + Str$(Xf)
     End If
     Del1 = Del2
Next i

' MEDIAN
Sum = 0
For i = 1 To IP
     Sum = Fpp(i) + Sum
     If (Sum - 50!) >= 0 Then Exit For
Next i
Xi = i - 1
CT = Emp1 + Xi * DPHI
ctMed = CT - (Sum - 50!) * DPHI / Fpp(i) + 0.5 * DPHI          ' take care div by zero
Fmt$ = "       \                \ =#0.00"
If flgDedug Then lstViewScreen.AddItem " MM Median  " + Str$(ctMed)
'IF Lprnt THEN LPRINT USING Fmt$; "Median"; CtMed

' Moments about the Mean
Sum = 0: Sum1 = 0: Sum2 = 0: Sum3 = 0: Sum4 = 0
For i = 1 To IP
     Xi = i - 1
     CT = Emp1 + Xi * DPHI
     Sum = Sum + Fpp(i)
     Sum1 = Sum1 + Fpp(i) * CT
     Sum2 = Sum2 + Fpp(i) * CT ^ 2
     Sum3 = Sum3 + Fpp(i) * CT ^ 3
     Sum4 = Sum4 + Fpp(i) * CT ^ 4
Next i
En1 = Sum1 / Sum
En2 = Sum2 / Sum
En3 = Sum3 / Sum
En4 = Sum4 / Sum
Zm2 = En2 - En1 ^ 2
Zm3 = En3 - 3! * En2 * En1 + 2! * En1 ^ 3
Zm4 = En4 + En1 * (-4 * En3 + 6! * En1 * En2 - 3! * En1 ^ 3)
DPHI2 = DPHI * DPHI
Zm4 = Zm4 - 0.5 * DPHI2 * Zm2 + 0.02916667 * DPHI2 * DPHI2      ' Shepard Cor. ???
Zm2 = Zm2 - DPHI2 / 12!
'PRINT En1; En2; En3; En4; Zm2; Zm3; Zm4

' Standard Deviation
Sigma = Sqr(Abs(Zm2))
' Skewness
Skew = 0.5 * Zm3 / (Sigma * Zm2)
' Kurtosis
ZKurt = Zm4 / Zm2 ^ 2 - 3!


If flgDedug Then lstViewScreen.AddItem "MM Mean =            " + Str$(En1)
If flgDedug Then lstViewScreen.AddItem "MM Std. Deviation =  " + Str$(Sigma)
If flgDedug Then lstViewScreen.AddItem "MM Skewness =        " + Str$(Skew)
If flgDedug Then lstViewScreen.AddItem "MM Kurtosis =        " + Str$(ZKurt)
If flgDedug Then lstViewScreen.AddItem ""

'If Lprnt Then
'     LPRINT USING Fmt$; "Mean"; En1
'     LPRINT USING Fmt$; "Standard Deviation"; Sigma
'     LPRINT USING Fmt$; "Skewness"; Skew
'     LPRINT USING Fmt$; "Kurtosis"; ZKurt
'     LPRINT Chr$(12)                         ' Form Feed
'End If

' write the data to disk

     For i = 1 To 3
          Print #2, Itext(i); ",";           ' Samp# Lat. Lon
     Next i
     Print #2, Format$(Gravel, "0.00") + "," + Format$(XSand, "0.00") + "," + Format$(Silt, "0.00") + "," + Format$(Clay, "0.00") + ",";
     Print #2, Verbal$; ",";
     
If intFlgs(2) = 1 Then                          ' Method of Moments

     Print #2, Format$(ctMed, "0.00") + "," + Format$(En1, "0.00") + "," + Format$(Sigma, "0.00") + "," + Format$(Skew, "0.00") + "," + Format$(ZKurt, "0.00") + ",";
     Print #2, ",";
     'If intFlgs(6) = 2 Then Print #2, "LINEAR,";
     'If intFlgs(6) = 3 Then Print #2, "EXPONENTIAL,";
     'If intFlgs(6) = 4 Then Print #2, "MEAN_L_E,";
Else                                            ' then it must be Inclusive Graphics
     Print #2, Format$(Phi50, "0.00") + "," + Format$(GrMean, "0.00") + "," + Format$(SDIG, "0.00") + "," + Format$(SkewIG, "0.00") + "," + Format$(GKurt, "0.00") + ",";
     Print #2, Vsort$ + "; " + Vskew$ + "; " + Vkurt$ + ",";
End If
If intFlgs(6) > 1 Then             ' Extrapolation was done
    For i = 19 To 1 Step -1
        If intFlgs(9) = 1 Then Print #2, Format$(FPcor(i), "0.00") + ",";   'round to 2 decimal places
        If intFlgs(9) = 2 Then Print #2, Format$(CFPcor(i), "0.00") + ",";   'round to 2 decimal places
    Next i
Else                            ' No Extrapolation
    Print #2, ",,";             ' Write two blank fields
    For i = 17 To 1 Step -1
        If intFlgs(9) = 1 Then Print #2, Format$(FPcor(i), "0.00") + ",";   'round to 2 decimal places
        If intFlgs(9) = 2 Then Print #2, Format$(CFPcor(i), "0.00") + ",";   'round to 2 decimal places
    Next i
End If
A$ = ""
If intFlgs(4) Then A$ = A$ + "ERROR CFP Not 100 "
If intFlgs(5) Then A$ = A$ + "ERROR Input missing a field "
If intFlgs(10) Then A$ = A$ + "ERROR Non-Numeric Character "
Print #2, A$

lstViewScreen.ListIndex = lstViewScreen.ListCount - 1

If Not EOF(1) Then GoTo NextSamp    ' start next record

Cls
Close #1
Close #2
Print
       
        lstViewScreen.AddItem "End of File - Files closed"
        lstViewScreen.ListIndex = lstViewScreen.ListCount - 1

        Sleep& = Timer
        Do                                          ' just wait a second
        Loop Until Timer > Sleep& + 1
        cmdRun.BackColor = &H8080FF                 ' pale Red
        cmdRestart.BackColor = &H80FFFF
        intFlgs(3) = 1                              'Run Done
        'Call CngFlgs

        'If intFlgs(4) Then lstViewScreen.AddItem "There were CFP errors. To troubleshoot search your output file for ERROR CFP", 2
        'If intFlgs(5) Then lstViewScreen.AddItem "There were input format errors. Search your output file for ERROR Input", 2
        'If intFlgs(10) Then lstViewScreen.AddItem "A non-Numeric character was found in a numeric input field. Search output for ERROR Non", 2
        If intFlgs(11) Then
            intPress = MsgBox("Errors were found in your input file" & Chr$(10) & "but an output file was written.", vbExclamation)
            intFlgs(11) = False
        End If
Exit Sub
AHError:
lstViewScreen.AddItem "ERROR # " + Str$(Err.Number) + " Has occurred. Procedure halted abnormally."
lstViewScreen.ListIndex = lstViewScreen.ListCount - 1
Close #1
Print #2, ""
Print #2, "ERROR # " + Str$(Err.Number) + " Has occurred. Procedure halted abnormally."
Close #2

End Sub
'DefDbl A-H, O-Z
Function SplineX3(intNP As Integer, intXval As Integer, xx() As Double, yy() As Integer)

'|-------------------------------------------------------------------------------
'| Function returns y value for a corresponding x value, based on cubic spline.
'| Will never oscillates or overshoot. No need to solve matrix.
'| Also calculate constants for cubic in case needed (for integration).
'|
'| xx(0 to No_of_lines) is x values
'|    * Must be unique (no two consequetive ones the same)
'|    * Must be in ascending order
'|    * No of lines = Number of points - 1
'| yy(0 to No_of_lines) is y values
'|
'| Uses function dxx to prevent div by zero.
'|
'| Developer: C Kruger, Guildford, UK
'| Date: December 2001
'|-------------------------------------------------------------------------------

Dim i As Integer
Dim j As Integer
Dim Nmax As Integer
Dim Num As Integer

'1st and 2nd derivative for left and right ends of line
Dim gxx(0 To 1) As Double
Dim ggxx(0 To 1) As Double

'Constants for cubic equations
Dim A As Double     'Also for linear extrapolation
Dim B As Double     'Also for linear extrapolation
Dim C As Double
Dim D As Double

'Number of lines = points - 1
'Nmax = UBOUND(xx)
Nmax = intNP
'(1a) Find LineNumber or segment. Linear extrapolate if outside range.
Num = 0
If intXval < xx(0) Or intXval > xx(Nmax) Then
  'X outisde range. Linear interpolate
  'Below min or max?
  If intXval < xx(0) Then Num = 1 Else Num = Nmax
  B = (yy(Num) - yy(Num - 1)) / dxx(xx(Num), xx(Num - 1))
  A = yy(Num) - B * xx(Num)
  SplineX3 = A + B * intXval
  Exit Function

'(1b) Find LineNumber or segment. Linear extrapolate if outside range.
Else
  'X in range. Get line.
  For i = 1 To Nmax
    If intXval <= xx(i) Then
      Num = i
      Exit For
    End If
  Next i
End If

'(2) Calc first derivative (slope) for intermediate points
For j = 0 To 1          'Two points around line
  i = Num - 1 + j
  If i = 0 Or i = Nmax Then
    'Set very large slope at ends
    gxx(j) = 10 ^ 30
  ElseIf (yy(i + 1) - yy(i) = 0) Or (yy(i) - yy(i - 1) = 0) Then
    'Only check for 0 dy. dx assumed NEVER equals 0 !
    gxx(j) = 0
  ElseIf ((xx(i + 1) - xx(i)) / (yy(i + 1) - yy(i)) + (xx(i) - xx(i - 1)) / (yy(i) - yy(i - 1))) = 0 Then
    'Pos PLUS neg slope is 0. Prevent div by zero.
    gxx(j) = 0
  ElseIf (yy(i + 1) - yy(i)) * (yy(i) - yy(i - 1)) < 0 Then
    'Pos AND neg slope, assume slope = 0 to prevent overshoot
    gxx(j) = 0
  Else
    'Calculate an average slope for point based on connecting lines
    gxx(j) = 2 / (dxx(xx(i + 1), xx(i)) / (yy(i + 1) - yy(i)) + dxx(xx(i), xx(i - 1)) / (yy(i) - yy(i - 1)))
  End If
Next j

'(3) Reset first derivative (slope) at first and last point
If Num = 1 Then
  'First point has 0 2nd derivative
  gxx(0) = 3 / 2 * (yy(Num) - yy(Num - 1)) / dxx(xx(Num), xx(Num - 1)) - gxx(1) / 2
End If
If Num = Nmax Then
  'Last point has 0 2nd derivative
  gxx(1) = 3 / 2 * (yy(Num) - yy(Num - 1)) / dxx(xx(Num), xx(Num - 1)) - gxx(0) / 2
End If

'(4) Calc second derivative at points
ggxx(0) = -2 * (gxx(1) + 2 * gxx(0)) / dxx(xx(Num), xx(Num - 1)) + 6 * (yy(Num) - yy(Num - 1)) / dxx(xx(Num), xx(Num - 1)) ^ 2
ggxx(1) = 2 * (2 * gxx(1) + gxx(0)) / dxx(xx(Num), xx(Num - 1)) - 6 * (yy(Num) - yy(Num - 1)) / dxx(xx(Num), xx(Num - 1)) ^ 2

'(5) Calc constants for cubic
D = 1 / 6 * (ggxx(1) - ggxx(0)) / dxx(xx(Num), xx(Num - 1))
C = 1 / 2 * (xx(Num) * ggxx(0) - xx(Num - 1) * ggxx(1)) / dxx(xx(Num), xx(Num - 1))
B = (yy(Num) - yy(Num - 1) - C * (xx(Num) ^ 2 - xx(Num - 1) ^ 2) - D * (xx(Num) ^ 3 - xx(Num - 1) ^ 3)) / dxx(xx(Num), xx(Num - 1))
A = yy(Num - 1) - B * xx(Num - 1) - C * xx(Num - 1) ^ 2 - D * xx(Num - 1) ^ 3

'Return function
SplineX3 = A + B * intXval + C * intXval ^ 2 + D * intXval ^ 3

''Alternative method based on Numerical Recipes.
''Shorter but does not calc cubic constants A, B, C, D
'i = Num
'A = (xx(i) - x) / (xx(i) - xx(i - 1))
'B = 1 - A
'Cy = 1 / 6 * (A ^ 3 - A) * (6 * (yy(i) - yy(i - 1)) - 2 * (gxx(i) + 2 * gxx(i - 1)) * (xx(i) - xx(i - 1)))
'Dy = 1 / 6 * (B ^ 3 - B) * (2 * (2 * gxx(i) + gxx(i - 1)) * (xx(i) - xx(i - 1)) - 6 * (yy(i) - yy(i - 1)))
''Return function
'SplineX3 = A * yy(i - 1) + B * yy(i) + Cy + Dy

End Function



Public Sub DoesInFileExist(intFlag)
      Dim FileInQuestion As String
      FileInQuestion = Dir(strInFile)       'StrInFile is global
      If FileInQuestion = "" Then
         intFlag = False
         MsgBox "The input file you have specified" + Chr$(10) + "does not exist at this location.", vbCritical
      Else
         intFlag = True
      End If
   End Sub
Public Sub DoesOutFileExist()               'nothing is returned because it is up to the user to go/nogo
      Dim FileInQuestion As String          ' after this warning.
      FileInQuestion = Dir(strOutFile)      ' strOutFile is global
      If FileInQuestion = "" Then
         'All is well
      Else
         MsgBox "WARNING: The output file you have specified already exists!" + Chr$(10) + "The file will be overwritten if the name is not changed.", vbInformation
      End If
   End Sub
 Function dxx(x1 As Double, x0 As Double)
'Calc Xi - Xi-1 to prevent div by zero

ddxx = x1 - x0
If ddxx = 0 Then ddxx = 10 ^ 30
dxx = ddxx
End Function

Private Sub Ffit(N As Integer, Xfit() As Integer, Yfit() As Double, IType As Integer, A, B)
    ' Curve fit subroutine
    '  Input Arguments:
    '
    '  N   = number of data points (N >= 3)
    '  Xfit() = vector of X data points ( N rows )
    '  Yfit() = vector of Y data points ( N rows )
    '  ITYPE = type of curve fit
    '      1 = linear       Y = A + B * X
    '      2 = logarithmic  Y = A + B * LOG(X)
    '      3 = exponential  Y = A * EXP(B * X)

    ' Output Arguments:

    '  A, B = coefficients of curve fit

    x1 = 0#
    Y1 = 0#
    Z = 0#
    X2 = 0#
    Y2 = 0#
   
    Select Case IType
    Case 1
         ' Linear
         For i = 1 To N
             x1 = x1 + Xfit(i)
             Y1 = Y1 + Yfit(i)
             X2 = X2 + Xfit(i) * Xfit(i)
             Y2 = Y2 + Yfit(i) * Yfit(i)
             Z = Z + Xfit(i) * Yfit(i)
         Next i
       
         x1 = x1 / N
         Y1 = Y1 / N
         B = (Z - N * x1 * Y1) / (X2 - N * x1 * x1)
         A = Y1 - B * x1
    Case 2
         ' Logarithmic
         For i = 1 To N
             XLOGX = Log(Xfit(i))
             x1 = x1 + XLOGX
             Y1 = Y1 + Yfit(i)
             X2 = X2 + XLOGX * XLOGX
             Y2 = Y2 + Yfit(i) * Yfit(i)
             Z = Z + XLOGX * Yfit(i)
         Next i

         x1 = x1 / N
         Y1 = Y1 / N

         B = (Z - N * x1 * Y1) / (X2 - N * x1 * x1)
         A = Y1 - B * x1
    Case 3
         ' Exponential
         For i = 1 To N
             XLOGY = Log(Yfit(i))
             x1 = x1 + Xfit(i)
             X2 = X2 + Xfit(i) * Xfit(i)
             Y1 = Y1 + XLOGY
             Y2 = Y2 + XLOGY * XLOGY
             Z = Z + Xfit(i) * XLOGY
         Next i

         x1 = x1 / N
         Y1 = Y1 / N

         B = (Z - N * x1 * Y1) / (X2 - N * x1 * x1)
         A = Exp(Y1 - B * x1)
     End Select

End Sub
  
   
   
Public Sub IsFileFormatOk(intFlag)
' Tests input file to see that it appears to be properly formatted for this program
    Dim FileInQuestion As String
    Dim i, j As Integer
    FileInQuestion = Dir(strInFile)
    Open FileInQuestion For Input As #1
    Line Input #1, Dat$
    j = 0
    For i = 1 To Len(Dat$)
        If Mid$(Dat$, i, 1) = "," Then j = j + 1
    Next i
    Close #1
    If j <> 19 Then         '20 parameters = 19 commas
        intFlag = False
        If j > 19 Then
            iOK = MsgBox("WARNING: The first record of this input file is not properly formatted." + Chr$(10) + "It may be an Output file.", vbOKCancel)
            If iOK = 1 Then intFlag = True
            If iOK = 2 Then intFlag = False
        Else
            MsgBox "WARNING: The first record of this input file is not properly formatted."
        End If
    If flgDedug Then lstViewScreen.AddItem Dat$
    Else
        intFlag = True
    End If
    Close #1
End Sub

Private Sub cmdClearWin_Click()
    lstViewScreen.Clear
    lstViewScreen.BackColor = &HFFFFFF          '  White
    
End Sub

Private Sub cmdExit_Click()
' Unload form and terminate application
    Unload frmGSSTATMain
    End
End Sub
Private Sub cmdRestart_Click()

    flgDebug = False
    
    cmdRestart.BackColor = &H8000000C
    cmdRun.BackColor = &H80FFFF
    'Frame1.BackColor = &H80FFFF                     ' back to yellow
    'optShep.BackColor = &H8000000C                  ' Grey
    'optFolk.BackColor = &H8000000C
    
    cmdSetInput.BackColor = &H80FFFF                ' lt yellow
    cmdSetOutput.BackColor = &H80FFFF               ' lt yellow
    LblInputFile.BackColor = &H8000000C
    LblOutputFile.BackColor = &H8000000C
    'strMethod = ""
    TxtInfilePath.BackColor = &H8000000C
    TxtOutfilePath.BackColor = &H8000000C
    cmdRun.BackColor = &H8000000C                   ' Grey in case it was previously validated
    TxtInfilePath.Text = "Not Selected"
    TxtOutfilePath.Text = "Not Selected"
    For i = 0 To 1: intFlgs(i) = 0: Next i
    For i = 3 To 5: intFlgs(i) = 0: Next i
    
    lstViewScreen.Clear
    lstViewScreen.AddItem "NOTICE:  Stat. Method, Extrap. Method, SMD, and Formats have NOT been changed."
End Sub



Private Sub cmdSetInput_Click()
dlgFiles.CancelError = True
On Error GoTo Errhandler
dlgFiles.FileName = strInFile
dlgFiles.DialogTitle = "Select File for Input"
dlgFiles.ShowOpen
  'Make sure your button's Style is Graphical to change colors
  
  strInFile = dlgFiles.FileName
  intFlag = False
  If (strInFile = strOutFile) Then                  'See if user changed anything
    TxtInfilePath.Text = strInFile
    intPress = MsgBox("The Input and Output Filenames can NOT be identical." + Chr$(10) + "Please modify the output filename.", vbExclamation)
    cmdSetOutput.BackColor = &H80FFFF
    intFlgs(1) = False
    TxtOutfilePath.Text = "Error"
    strOutFile = ""
  Else
    Call DoesInFileExist(intFlag)                   'See if the file exists
    If intFlag Then Call IsFileFormatOk(intFlag)    'See if it has 19? fields per line
                                                    ' OR user says it is OK
    If intFlag Then
        cmdSetInput.BackColor = &H80FF80            'all OK Change the button to green
        TxtInfilePath.BackColor = &HFFFFFF
        TxtInfilePath.Text = strInFile
        intFlgs(0) = 1                              'All is well
        Call CngFlgs
    Else                                            'Bad File or The user changed the file to a bad name
        cmdSetInput.BackColor = &H80FFFF            'Problem Change the button to Yellow
        TxtInfilePath.BackColor = &HFFFFFF
        TxtInfilePath.Text = "Error"
        intFlgs(0) = 0
        Call CngFlgs
    End If
    
    Call RunStat(0)
  End If
Errhandler:
    'user clicked cancel
End Sub

Private Sub cmdSetOutput_Click()
dlgFiles.CancelError = True
On Error GoTo Errhandler
dlgFiles.FileName = strOutFile
dlgFiles.DialogTitle = "Set File for Output"
dlgFiles.ShowSave
  'Make sure your button's Style is Graphical
  'test valid file opened
  intFlgs(1) = True
  strOutFile = dlgFiles.FileName
  If (strInFile = strOutFile) Then                  'See if user changed anything
    TxtOutfilePath.Text = strOutFile
    intPress = MsgBox("The Input and Output Filenames cannot be identical", vbExclamation)
  Else
    cmdSetOutput.BackColor = &H80FF80               'Change the button to green
    TxtOutfilePath.BackColor = &HFFFFFF
    TxtOutfilePath.Text = strOutFile
  Call RunStat(0)
  Call DoesOutFileExist
  End If
Errhandler:                                         ' user hit cancel
End Sub

Private Sub cmdAbout_Click()
frmAbout.Show
'intPress = MsgBox("Program GSSTAT  Programmer A.H. Eliason - May 2003  Eliason Data Services  508-477-3155", vbInformation)
End Sub
Private Sub Extrapinfo()
lstViewScreen.BackColor = &HC0FFFF          ' very light Yellow
lstViewScreen.AddItem "Please READ the following carefully:"
lstViewScreen.AddItem "   You have elected to extrapolate the fine end of the distribution from the smallest"
lstViewScreen.AddItem " measured size to 13 phi. This may be done by LINEAR or EXPONENTIAL  "
lstViewScreen.AddItem " extrapolation, or the MEAN of both sets of results. "
lstViewScreen.AddItem "   Linear extrapolation may tend to over-estimate the clay present, while exponential"
lstViewScreen.AddItem " may under-estimate. It is up to the operator to determine the best method based"
lstViewScreen.AddItem " upon the user's intended application."
lstViewScreen.AddItem "   The program needs to know the smallest measured size. If the smallest measured"
lstViewScreen.AddItem " size exceeds 2.0 microns, the user will be warned that a significant part of the"
lstViewScreen.AddItem " distribution is being extrapolated and that the statistics may be invalid."
lstViewScreen.AddItem ""
'
'Size:
     'Print
     'Do
     '     INPUT "        Smallest measured micron diameter"; UD
     'Loop While UD <= 0
     'If UD < 0.5 Or UD > 0.8 Then
     '     Print USING; "   You have entered a value which corresponds to ###.## Phi"; U2Phi(UD)
     '     INPUT "   Is this correct (Y/N)? ", A$
     '     If UCase$(Left$(A$, 1)) <> "Y" Then GoTo Size:
     'End If
     
'
End Sub


Private Sub Option1_Click()
intFlgs(8) = 1                      'set input format = FP
Call CngFlgs
End Sub

Private Sub Option2_Click()
intFlgs(8) = 2                      'set input format = CFP
Call CngFlgs
End Sub

Private Sub Option3_Click()
intFlgs(9) = 1                      'set output format = FP
Call CngFlgs
End Sub

Private Sub Option4_Click()
intFlgs(9) = 2                      'set output format = CFP
Call CngFlgs
End Sub

Private Sub optMM_Click()
Frame1Stat.BackColor = &H8000000C
optMM.BackColor = &H80FF80
optIG.BackColor = &H8000000C
strMethod = "MM"
intFlgs(2) = 1
Call CngFlgs
Call RunStat(0)
End Sub

Private Sub optIG_Click()
Frame1Stat.BackColor = &H8000000C
optIG.BackColor = &H80FF80
optMM.BackColor = &H8000000C
strMethod = "IG"
intFlgs(2) = 2
Call CngFlgs
Call RunStat(0)
End Sub

Private Sub optENone_Click()
Frame_Extrap.BackColor = &H8000000C
optENone.BackColor = &H80FF80
optELin.BackColor = &H8000000C
optEExp.BackColor = &H8000000C
optEAvg.BackColor = &H8000000C
strExtrap = "None"
intFlgs(6) = 1
intFlgs(7) = 0
Call CngFlgs
Call RunStat(0)
If intFlgs(6) = 1 Then FrameSMD.BackColor = &H8000000C
End Sub

Private Sub optELin_Click()
Call Extrapinfo
Frame_Extrap.BackColor = &H8000000C
optENone.BackColor = &H8000000C
optELin.BackColor = &H80FF80
optEExp.BackColor = &H8000000C
optEAvg.BackColor = &H8000000C
strExtrap = "Linear"
intFlgs(6) = 2
intFlgs(7) = 1
Call CngFlgs
Call RunStat(0)
If intFlgs(6) > 1 Then FrameSMD.BackColor = &H80FFFF
End Sub
Private Sub optEExp_Click()
Call Extrapinfo
Frame_Extrap.BackColor = &H8000000C
optENone.BackColor = &H8000000C
optELin.BackColor = &H8000000C
optEExp.BackColor = &H80FF80
optEAvg.BackColor = &H8000000C
strExtrap = "Exponential"
intFlgs(6) = 3
intFlgs(7) = 1
Call CngFlgs
Call RunStat(0)
If intFlgs(6) > 1 Then FrameSMD.BackColor = &H80FFFF
End Sub
Private Sub optEAvg_Click()
Call Extrapinfo
Frame_Extrap.BackColor = &H8000000C
optENone.BackColor = &H8000000C
optELin.BackColor = &H8000000C
optEExp.BackColor = &H8000000C
optEAvg.BackColor = &H80FF80
strExtrap = "Averaged"
intFlgs(6) = 4
intFlgs(7) = 1
Call CngFlgs
Call RunStat(0)
If intFlgs(6) > 1 Then FrameSMD.BackColor = &H80FFFF


End Sub
Private Sub TextSMD_Change()

If LCase$(TextSMD) = "debug" Then
    flgDebug = True
    intPress = MsgBox("Debug mode has been set to ON", vbExclamation)
    TextSMD = ""
Else
    FrameSMD.BackColor = &H8000000C
    SMD = Val(TextSMD)
End If
If SMD > 0.001 And SMD < 5 Then
    intFlgs(7) = 0
    Call CngFlgs
    Call RunStat(0)
End If
End Sub
Private Sub RunStat(iRun)
If intFlgs(0) And intFlgs(1) And Not intFlgs(5) And Not intFlgs(7) Then
    cmdRun.BackColor = &H80FFFF     'Pale Yellow
    iRun = True
Else
    cmdRun.BackColor = &H8080FF     'Pale Red
    iRun = False
End If
' init/change the file i/o formats
If Option1.Value Then intFlgs(8) = 1      ' init for FP input format
If Option2.Value Then intFlgs(8) = 2      ' init for CFP input format
If Option3.Value Then intFlgs(9) = 1      ' init for FP output format
If Option4.Value Then intFlgs(9) = 2      ' init for CFP output format
Call CngFlgs
End Sub

Private Function U2Phi(Usize)
' convert micron size to phi
     Phi = -2.12720466241656E-16 + (-1.44269504088896) * Log(Usize / 1000)
     'If flgDebug Then lstViewScreen " mm = " + Str$(Usize)
     'If flgDebug Then lstViewScreen " phi= " + Str$(Phi)
     U2Phi = Phi
End Function
Private Sub CngFlgs()
'MsgBox "Var intFlgs() Changed"
If flgDebug Then
    A$ = ""
    If Not intFlgs(0) Then A$ = A$ + "InFile F "
    If intFlgs(0) Then A$ = A$ + "InFile T "
    If Not intFlgs(1) Then A$ = A$ + "OutF F "
    If intFlgs(1) Then A$ = A$ + "OutF T "
    If intFlgs(2) = 0 Then A$ = A$ + "NoStat "
    If intFlgs(2) = 1 Then A$ = A$ + "Momnts "
    If intFlgs(2) = 2 Then A$ = A$ + "IncGR "
    If Not intFlgs(3) Then A$ = A$ + "Pend "
    If intFlgs(3) Then A$ = A$ + "Done "
    If intFlgs(4) Then A$ = A$ + "CFP-ERR "
    If intFlgs(5) Then A$ = A$ + "M.F.ERR "
    If intFlgs(6) = 0 Then A$ = A$ + "ENS "
    If intFlgs(6) = 1 Then A$ = A$ + "NoEx "
    If intFlgs(6) = 2 Then A$ = A$ + "Lin "
    If intFlgs(6) = 3 Then A$ = A$ + "Exp "
    If intFlgs(6) = 4 Then A$ = A$ + "Avg "
    If intFlgs(7) = 0 Then A$ = A$ + "SMDok "
    If intFlgs(7) = 1 Then A$ = A$ + "noSMD "
    If intFlgs(7) = 2 Then A$ = A$ + "SMDOR "
    If intFlgs(8) = 1 Then A$ = A$ + "FPin "
    If intFlgs(8) = 2 Then A$ = A$ + "CFPin "
    If intFlgs(9) = 1 Then A$ = A$ + "FpOut "
    If intFlgs(9) = 2 Then A$ = A$ + "CfpOut "
    If intFlgs(10) Then A$ = A$ + "BadChar"
    'If intFlgs(1) = 0 Then A$ = A$ + ""
    'If intFlgs(1) = 0 Then A$ = A$ + ""
    'If intFlgs(1) = 0 Then A$ = A$ + ""
    
    If flgDebug Then lstViewScreen.AddItem "Debug status: " + A$
    A$ = ""
End If
    
End Sub
Private Sub TestValNum()
    If Not ValidateNumeric(strNumIn) Then
        intFlgs(10) = True
    End If
End Sub
Private Function ValidateNumeric(strText As String) As Boolean
ValidateNumeric = CBool(strText = "" _
    Or strText = "-" _
    Or strText = "-." _
    Or strText = "." _
    Or IsNumeric(strText))
End Function

